#!/usr/bin/python
###############################################################################
# This file is part of openWNS (open Wireless Network Simulator)
# _____________________________________________________________________________
#
# Copyright (C) 2004-2007
# Chair of Communication Networks (ComNets)
# Kopernikusstr. 16, D-52074 Aachen, Germany
# phone: ++49-241-80-27910,
# fax: ++49-241-80-22242
# email: info@openwns.org
# www: http://www.openwns.org
# _____________________________________________________________________________
#
# openWNS is free software; you can redistribute it and/or modify it under the
# terms of the GNU Lesser General Public License version 2 as published by the
# Free Software Foundation;
#
# openWNS is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
# A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
# details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
# Looks for all TLA projects and prints the MAINTAINER information
# from the "MAINTAINER" file (or if not found, unmaintained).

import os

for (dirname, dirs, files) in os.walk("."):
    if "{arch}" in dirs and not "++pristine-trees" in dirname:
        print "Maintainer for " + dirname + ":"
        if not "MAINTAINER" in files:
            print "  unmaintained"
        else:
            for line in file(os.path.join(dirname, "MAINTAINER")):
                print "  " + line.strip()
        print
